;Scripts by Tim Burgess of Raised Bar LTD:
;http://www.raisedbar.net/
Include "HJConst.JSH"
Include "HJGlobal.JSH"
Include "common.jsm" ; message file
use "HotSpotClicker.jsb" 
include "HotSpotClicker.jsh"
Void Function FocusChangedEvent (handle FocusWindow, handle PrevWindow)

If (GetWindowName( FocusWindow) == "Window") then
Return;
EndIf;

HSCFocusChanged (GetWindowname (GetTopLevelWindow (FocusWindow)))
; now call the version in default.jss.
FocusChangedEvent (FocusWindow, PrevWindow)
EndFunction


int Function HandleCustomWindows (handle hFocus)
if (HSCCheckForPrompt (hFocus)) then
; a prompt exists for this window
; if you specify a processing function for the prompt, it can say the window contents.
; So we are done.
return(1) ; indicate that we took care of it.
Endif
; include any other logic you need for other purposes.
; return 1 if you don't want jaws default processing to do any more speaking.
return(0) ; means we did not handle this window, so jaws should take care of it itself
EndFunction


void Function SayHighlightedText( Handle hwnd, String buffer)
if (buffer == "window") Then
Return
EndIf;
EndFunction
Script AssignOutput ()
Var
	String sOutputs,
	Int iOutputNumber,
	String sOutputName;

Let sOutputs = "1|2|3|4|5|6|7|8|9|10|11|12|13|14|15|16|17|18|19|20|21|22|"

Let iOutputNumber = DlgSelectItemInList (sOutputs, "Choose output To assign.", FALSE, 1);

If (iOutputNumber > 0) Then
	Let sOutputName = "Out " + IntToString( iOutputNumber);
	HSCLookupKey( sOutputName);
	Else
	SayString( "Output assignment cancelled.");
EndIf
EndScript


Script AssignInput ()
Var
	String sInputs,
	Int iInputNumber,
	String sInputName;

Let sInputs = "1|2|3|4|5|6|7|8|9|10|11|12|13|14|15|16|17|18"

Let iInputNumber = DlgSelectItemInList (sInputs, "Choose Input To assign.", FALSE, 1);

If (iInputNumber > 0) Then
	Let sInputName = "In " + IntToString( iInputNumber);
	HSCLookupKey( sInputName);
	Else
	SayString( "Input assignment cancelled.");
EndIf
EndScript


Script AssignInputLabel ()
Var
	String sInputs,
	Int iInputNumber,
	String sInputName;

Let sInputs = "1|2|3|4|5|6|7|8|9|10|11|12|13|14|15|16|DAW"

Let iInputNumber = DlgSelectItemInList (sInputs, "Choose Input To label.", FALSE, 1);

If (iInputNumber == 0) Then
	SayString( "Input labeling cancelled.");
	Return;

ElIf (iInputNumber == 17) Then
	Let sInputName = "In DAW Label";
ElIf (iInputNumber > 0) && (iInputNumber < 17) Then
	Let sInputName = "In " + IntToString( iInputNumber) + " Label";
EndIf

HSCLookupKey( sInputName);
EndScript


Script SelectMute ()
Var
	String sMutes,
	Int iMuteNumber,
	String sMuteName;

Let sMutes = "1|2|3|4|5|6|7|8|9|10|11|12|13|14|15|16"

Let iMuteNumber = DlgSelectItemInList (sMutes, "Choose an input To mute.", FALSE, 1);

If (iMuteNumber > 0) Then
	Let sMuteName = IntToString( iMuteNumber) + " Mute";
	HSCLookupKey( sMuteName);
	Else
	SayString( "Mute selection cancelled.");
EndIf
EndScript


Script SelectSolo ()
Var
	String sSolos,
	Int iSoloNumber,
	String sSoloName;

Let sSolos = "1|2|3|4|5|6|7|8|9|10|11|12|13|14|15|16"

Let iSoloNumber = DlgSelectItemInList (sSolos, "Choose an input To solo.", FALSE, 1);

If (iSoloNumber > 0) Then
	Let sSoloName = IntToString( iSoloNumber) + " Solo";
	HSCLookupKey( sSoloName);
	Else
	SayString( "Solo selection cancelled.");
EndIf
EndScript


Script SelectPFL ()
Var
	String sPFLs,
	Int iPFLNumber,
	String sPFLName;

Let sPFLs = "1|2|3|4|5|6|7|8|9|10|11|12|13|14|15|16"

Let iPFLNumber = DlgSelectItemInList (sPFLs, "Change PFL for which input?", FALSE, 1);

If (iPFLNumber > 0) Then
	Let sPFLName = IntToString( iPFLNumber) + " PFL";
	HSCLookupKey( sPFLName);
	Else
	SayString( "PFL selection cancelled.");
EndIf
EndScript


Script SelectedChannelLinkage ()
Var
	String sLinks,
	Int iLinkNumber,
	String sLinkName;

Let sLinks = "1/2|3/4|5/6|7/8|9/10|11/12|13/14|15/16"

Let iLinkNumber = DlgSelectItemInList (sLinks, "Link/unlink inputs", FALSE, 1);

If (iLinkNumber > 0) Then
Let iLinkNumber = (iLinkNumber * 2) - 1;
	Let sLinkName = "Link " + IntToString( iLinkNumber) + "/" + IntToString( iLinkNumber + 1) ;
	HSCLookupKey( sLinkName);
	Else
	SayString( "Channel linkage selection cancelled.");
EndIf
EndScript


Script ChooseActiveOutputForSelectedMix  ()
Var
	String sOutputs,
	Int iOutputNumber,
	String sOutputName;

Let sOutputs = "Out A|Out B";
Let iOutputNumber = DlgSelectItemInList (sOutputs, "Choose the output for this mix.", FALSE, 1);

If (iOutputNumber ==1) Then
	Let sOutputName = "Out A";
	HSCLookupKey( sOutputName);

	ElIf (iOutputNumber ==2) Then
	Let sOutputName = "Out B";
	HSCLookupKey( sOutputName);

	Else
	SayString( "Output assignment cancelled.");
EndIf
EndScript

;script for speaking fader values, added by Peter Torpey
;Void Function SpeakControlValue ()
;var
;	string sControl,
;	string sControlNumber,
 ; string sText,
  ;int iSpeechOff

; check to see if the left mouse button is locked
;if !IsLeftButtonDown ()  then
;	SayString("the left mouse button must be locked in order to change this controler's value")
;	return
;EndIf

;; check to see if the last spot was a control with an associated number;
;if StringSegmentCount (HSLastSpot, " ")==2 then
;	let sText = HSLastSpot
;	let sControl = StringSegment (HsLastSpot, " ", 1)
;	let sControlNumber = StringSegment (HsLastSpot, " ", 2)
	; speak the value of this control
;	Delay(10)
;	; unlock left mouse button
;	LeftMouseButtonLock ()
;	HSCLookupKey( sText + " " + "Value" )

;	; go back to where we were so that the controller value can be changed again if desired
;	let iSpeechOff = IsSpeechOff ()
;	SpeechOff ()
	; re-set HSLastSpot so that Alt+Arrow keys wil speak again if the control value is changed
;	let HSLastSpot = sText
;	HSCLookupKey( HSLastSpot)
;	Pause()
	; re-lock the left mouse button
;	LeftMouseButtonLock ()
;	if !iSpeechOff then SpeechOn () EndIf
;	EndIf

;EndFunction

;script MouseDown()
;MouseDown Script
;MouseDown (GlobalMousePixel)
;SayFormattedMessage (ot_status, cmsg59_L, cmsg59_S) ;"Mouse Down"
;SpeakControlValue()
;EndScript

;script MouseUp()
;MouseUp Script
;MouseUp (GlobalMousePixel)
;SayFormattedMessage (ot_status, cmsg60_L, cmsg60_S) ;"Mouse Up"
;SpeakControlValue()
;EndScript

;script MouseLeft()
;MouseLeft Script
;MouseLeft (GlobalMousePixel)
;SayFormattedMessage (ot_status, cmsg57_L, cmsg57_S) ;"Mouse Left"
;SpeakControlValue()
;EndScript

;script MouseRight()
;MouseRight Script
;MouseRight (GlobalMousePixel)
;SayFormattedMessage (ot_status, cmsg58_L, cmsg58_S) ;"Mouse Right"
;SpeakControlValue()
;EndScript
